%define _unpackaged_files_terminate_build 0
Name:           lib-aws-sdk
Version:        1.11.587
Release:        1%{?dist}
Summary:        AWS SDK for C++ (S3 only)

License:        Apache-2.0
URL:            https://github.com/aws/aws-sdk-cpp

BuildRequires:  git, cmake, gcc, gcc-c++, openssl-devel, libcurl-devel, zlib-devel, libuuid-devel
Requires:       openssl, libcurl, zlib, libuuid

%description
The AWS SDK for C++ provides libraries for various AWS services, including S3.

%package devel
Summary: Development files for AWS SDK for C++
Requires: %{name} = %{version}-%{release}

%description devel
Headers and development libraries for AWS SDK for C++.

%prep
rm -rf %{_builddir}/aws-sdk-cpp
git clone --recursive https://github.com/aws/aws-sdk-cpp.git %{_builddir}/aws-sdk-cpp
cd %{_builddir}/aws-sdk-cpp
git checkout %{version}
git submodule update --init --recursive

%build
mkdir -p %{_tmppath}/aws_s3_build
cp -a %{_builddir}/aws-sdk-cpp/* %{_tmppath}/aws_s3_build/

cd %{_tmppath}/aws_s3_build
mkdir -p build
cd build

cmake .. \
  -DCMAKE_BUILD_TYPE=Release \
  -DCMAKE_INSTALL_PREFIX=%{_prefix} \
  -DBUILD_ONLY="s3" \
  -DBUILD_SHARED_LIBS=ON

cmake --build . -- -j$(nproc)

%install
cd %{_tmppath}/aws_s3_build/build
cmake --install . --prefix=%{buildroot}%{_prefix}

# Create unversioned symlinks for devel package
ln -sf libaws-c-auth.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-auth.so
ln -sf libaws-c-cal.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-cal.so
ln -sf libaws-c-common.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-common.so
ln -sf libaws-c-compression.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-compression.so
ln -sf libaws-c-event-stream.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-event-stream.so
ln -sf libaws-c-http.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-http.so
ln -sf libaws-c-io.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-io.so
ln -sf libaws-c-mqtt.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-mqtt.so
ln -sf libaws-c-s3.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-s3.so
ln -sf libaws-c-sdkutils.so.1.0.0 %{buildroot}%{_libdir}/libaws-c-sdkutils.so
ln -sf libaws-checksums.so.1.0.0 %{buildroot}%{_libdir}/libaws-checksums.so


%files
%{_libdir}/libaws-c-auth.so.1.0.0
%{_libdir}/libaws-c-cal.so.1.0.0
%{_libdir}/libaws-c-common.so.1.0.0
%{_libdir}/libaws-c-compression.so.1.0.0
%{_libdir}/libaws-c-event-stream.so.1.0.0
%{_libdir}/libaws-c-http.so.1.0.0
%{_libdir}/libaws-c-io.so.1.0.0
%{_libdir}/libaws-c-mqtt.so.1.0.0
%{_libdir}/libaws-c-s3.so.1.0.0
%{_libdir}/libaws-c-sdkutils.so.1.0.0
%{_libdir}/libaws-checksums.so.1.0.0
%{_libdir}/libaws-cpp-sdk-core.so
%{_libdir}/libaws-cpp-sdk-s3.so
%{_libdir}/libaws-crt-cpp.so

%files devel
%{_includedir}/aws

%{_libdir}/libaws-c-auth.so
%{_libdir}/libaws-c-cal.so
%{_libdir}/libaws-c-common.so
%{_libdir}/libaws-c-compression.so
%{_libdir}/libaws-c-event-stream.so
%{_libdir}/libaws-c-http.so
%{_libdir}/libaws-c-io.so
%{_libdir}/libaws-c-mqtt.so
%{_libdir}/libaws-c-s3.so
%{_libdir}/libaws-c-sdkutils.so
%{_libdir}/libaws-checksums.so

%{_libdir}/libaws-cpp-sdk-core.so
%{_libdir}/libaws-cpp-sdk-s3.so
%{_libdir}/libaws-crt-cpp.so
